/**
 * 带选择的分页表格
 * qcc
 * 2018/8/17
 */

!(function () {
    var Table = BI.inherit(BI.Widget, {

        props: {
            baseCls: "dec-check-page-table",
            $testId: "dec-check-page-table",
            perPage: 10,
            columnSize: [],
            items: [],
            showCheckBox: true,
            pagerInvisible: false,
            asyncGetTotal:false,
            sortList:[],
        },

        _store: function () {
            this.items = this.options.items;

            return BI.Models.getModel("dec.factory.model.check.page.table.base", {
                pageIds: this._createIds(),
            });
        },

        watch: {
            pageIds: function () {

                this.listGroup.populate(this._createItems(this.items));
            },

            sort: function (v) {
                this.fireEvent(Table.EVENT_SORT, v);
            },

            "totalCount || currentPage||refreshPager": function () {
                this.pager.setCount(this.model.totalCount);
                this.pager.setPage(this.model.currentPage);
                this.pager.setAllPages(Math.ceil(this.model.totalCount / this.options.perPage));
            },
        },

        render: function () {
            var self = this, o = this.options;
            if(o.asyncGetTotal){
                 o.getTotal(function (result) {
                     self.model.totalCount = result.data;

                });
            }

            return {
                type: "bi.vtape",

                rowSize: [30, "fill", 30],
                items: [{
                    type: "dec.factory.check.page.table.header.base",
                    height:30,
                    columnSize: o.columnSize,
                    items: o.header,
                    sortList:o.sortList,
                    showCheckBox: o.showCheckBox,
                    listeners: [{
                        eventName: "EVENT_SORT_CHANGE",
                        action: function (v) {

                            self.fireEvent("EVENT_SORT_CHANGE", v);
                        },
                    }],
                }, {
                    type: "bi.button_group",
                    cls: "table-items",
                    layouts: [{
                        type: "bi.vertical",
                        top:30
                    }],
                    items: this._createItems(),
                    ref: function (_ref) {
                        self.listGroup = _ref;
                    },
                }],
                listeners: [{
                    eventName: "EVENT_SORT_CHANGE",
                    action: function (sortKey) {

                        self.fireEvent("EVENT_SORT_CHANGE", sortKey);
                    },
                }],
            };
        },

        setCount: function (v) {

            this.store.setCount(v);
        },

        setPage: function (v) {
            this.store.setPage(v);
        },
        reloadPage:function(){
            this.store.setRefreshPager();
        },

        populate: function (items) {
            this.items = items;
            this.store.setPageIds(this._createIds());
        },

        getValue: function () {
            return this.model.selectedIds;
        },

        _createItems: function () {
            var o = this.options;
            // model里面不能传function，所以不能直接传进去
            return BI.map(this.items, function (i, v) {
                var id = v.id, val = BI.deepClone(v);
                var canSelect = v.editable == null || v.editable == undefined || v.editable;
                delete val.id;
                delete val.editable;
                return {
                    type: "dec.factory.check.page.table.row.base",
                    odd: BI.isOdd(i),
                    canSelect: canSelect,
                    columnSize: o.columnSize,
                    id: id,
                    item: val,
                    showCheckBox: o.showCheckBox,
                };
            });
        },

        _createIds: function () {
            var result = [];
            BI.each(this.items, function (i, v) {
                var id = v.id || BI.UUID();
                v.id = id;
                if (v.editable == null || v.editable == undefined || v.editable) {
                    result.push(id);
                }
            });
            return result;
        },
    });
    Table.PAGER_EVENT_CHANGE = "EVENT_CHANGE";
    Table.EVENT_SORT = "EVENT_SORT";
    BI.shortcut("dec.factory.check.page.table.base", Table);
}());
!(function () {
    var Model = BI.inherit(Fix.Model, {

        state: function () {
            return {
                sort: {},
                refreshPager: "",
                selectedIds: [],
                pageIds: this.options.pageIds,
                currentPage: 1,
                totalCount: 0,
            };
        },
        childContext: ["sort", "selectedIds", "pageIds"],

        computed: {},

        actions: {
            setCount: function (v) {
                this.model.totalCount = v;
            },

            setPage: function (v) {
                this.model.currentPage = v;
            },

            setPageIds: function (v) {
                this.model.pageIds = v;
                this.model.selectedIds = [];
            },
            setRefreshPager: function () {
                this.model.refreshPager = BI.UUID();

            }
        },
    });
    BI.model("dec.factory.model.check.page.table.base", Model);
}());
